"use strict";
/* -------------------------------------------------------------------------------------------
 * Copyright (c) RedShift Development LLC
 * Licensed under the MIT license. See License.txt in the project root for license information
 * ---------------------------------------------------------------------------------------- */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NewServiceClient = void 0;
const NewServiceClient = (name, ipc) => {
    const request = (method, data) => __awaiter(void 0, void 0, void 0, function* () {
        try {
            const resData = yield ipc.invoke('rsipc-request', name, method, JSON.stringify(data));
            // should not return, should parse then look for data or error key, return or throw accordingly
            return resData;
        }
        catch (e) {
            // Something went wrong during the request or JSON parsing. Throw the error
            throw new Error(e);
        }
    });
    return { request };
};
exports.NewServiceClient = NewServiceClient;
//# sourceMappingURL=client.js.map